//------------------------------------------------------------------------------
//
//  npmapfile.h
//
//  ANTz application based on NPE
//
//  Created by Shane Saxon on 3/13/11.
//  Copyright Saxon Digital 2010-2011. All rights reserved.
//
// formats the data for import and export of CSV, TDT, XML, JSON, KML, OBJ, etc
// we map all of our data into tables and describe the variable types separately
// this is done using a JSON schema formatted to be compatible with export and
// import to XML (office 2003 format), also generates native binary, CSV, TDT 
// and JSON files. GIS using GDAL for KML and OBJ files.
// also generates native binary for performance and support GIS using GDAL lib.
// *note that this description is not fully implemented at this time
//------------------------------------------------------------------------------

#ifndef NPMAPFILE_H_
#define NPMAPFILE_H_


#include <stdio.h>
#include "../npdata.h"

#define kNPmapFileWriteBufferSize 128000000

void npInitMapFile (void* dataRef);
void npCloseMapFile (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenMapFile (const char* fileName, const char* mode, void* dataRef);

FILE* npNewMapFile (const char* fileName, const char* mode, void* dataRef);

FILE* npDialogMapFile (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npCloseMapFile (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadMapFile (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteMapFile (const void* str, int wordSize, int size, FILE* file, void* dataRef);

int npWriteNode (char* buffer, void* nodeRef, void* dataRef);
// 
void npSaveMapFile (FILE* file, void* dataRef);

int npImportMapFile (FILE* file, int type, void* dataRef);
int npExportMapFile (FILE* file, int type, void* dataRef);

// file and directory management
int npGetMapFile (char* buffer, int count, void* nodeRef, void* dataRef);

void npSetChannelFile (char* fileName, int wordSize, int size, void* dataRef);

void npSetMapFile (char* fileName, int wordSize, int size, void* dataRef);

void npTestMapFile (void* fileName, int wordSize, int size, void* dataRef);


#endif