//------------------------------------------------------------------------------
//
//  main.c
//  ANTZ application based on NPE
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#include "npdata.h"
#include "npio.h"
#include "npctrl.h"


// MVC architecture, View renamed to "IO" and includes GPU, keyboard, mice...
//------------------------------------------------------------------------------
int main(int argc, char **argv)
{
	int err = 0;
	void* data = NULL;


	npInitData (argc, argv, data);			// Model
	npInitIO (data);						// View
	npInitCtrl (data);						// Control
	
	err = npAppLoop (data);

	npCloseCtrl (data);
	npCloseIO (data);
	npCloseData (data);


	return err;
}

